function RK4acceleration(state, dir)
{
   r = -0.1;
   return r;
}
function RK4evaluate(initial, dt, d, dir)
{
   var _loc1_ = new Object();
   if(d.dx != undefined)
   {
      _loc1_.x = initial.x + d.dx * dt;
      _loc1_.v = initial.v + d.dv * dt;
   }
   else
   {
      _loc1_.x = initial.x;
      _loc1_.v = initial.v;
   }
   var _loc2_ = new Object();
   if(d.dx != undefined)
   {
      _loc2_.dx = _loc1_.v;
      _loc2_.dv = RK4acceleration(_loc1_,dir);
   }
   else
   {
      _loc2_.dx = _loc1_.v;
      _loc2_.dv = RK4acceleration(_loc1_,dir);
   }
   return _loc2_;
}
function RK4Integrate(state, dt, dir)
{
   var _loc5_ = RK4evaluate(state,0,dir);
   var _loc4_ = RK4evaluate(state,dt * 0.5,_loc5_,dir);
   var _loc3_ = RK4evaluate(state,dt * 0.5,_loc4_,dir);
   var _loc7_ = RK4evaluate(state,dt,_loc3_,dir);
   var _loc9_ = 0.16666666666666666 * (_loc5_.dx + 2 * (_loc4_.dx + _loc3_.dx) + _loc7_.dx);
   var _loc8_ = 0.16666666666666666 * (_loc5_.dv + 2 * (_loc4_.dv + _loc3_.dv) + _loc7_.dv);
   state.x += _loc9_ * dt;
   state.v += _loc8_ * dt * dir;
   if(state.v < 0 && dir == 1)
   {
      state.v = 0;
   }
   if(state.v > 0 && dir == -1)
   {
      state.v = 0;
   }
   return state;
}
stop();
